package gregapi.item.multiitem.food;

import gregapi.data.CS.DrinksGT;
import gregapi.item.multiitem.MultiItemRandom;

import java.util.List;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.EnumAction;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidStack;

public class FoodStatLink implements IFoodStat {
	public final IFoodStat mStats;
	
	public FoodStatLink(IFoodStat aStats) {
		mStats = aStats;
	}
	public FoodStatLink(String aFluid) {
		mStats = DrinksGT.REGISTER.get(aFluid);
	}
	public FoodStatLink(Fluid aFluid) {
		mStats = DrinksGT.REGISTER.get(aFluid.getName());
	}
	public FoodStatLink(FluidStack aFluid) {
		mStats = DrinksGT.REGISTER.get(aFluid.getFluid().getName());
	}
	
	@Override
	public int getFoodLevel(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.getFoodLevel(aItem, aStack, aPlayer);
	}
	
	@Override
	public float getSaturation(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.getSaturation(aItem, aStack, aPlayer);
	}
	
	@Override
	public float getHydration(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.getHydration(aItem, aStack, aPlayer);
	}
	
	@Override
	public float getTemperature(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.getTemperature(aItem, aStack, aPlayer);
	}
	
	@Override
	public float getTemperatureEffect(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.getTemperatureEffect(aItem, aStack, aPlayer);
	}
	
	@Override
	public boolean alwaysEdible(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.alwaysEdible(aItem, aStack, aPlayer);
	}
	
	@Override
	public boolean isRotten(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.isRotten(aItem, aStack, aPlayer);
	}
	
	@Override
	public EnumAction getFoodAction(MultiItemRandom aItem, ItemStack aStack) {
		return mStats.getFoodAction(aItem, aStack);
	}
	
	@Override
	public boolean useAppleCoreFunctionality(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		return mStats.useAppleCoreFunctionality(aItem, aStack, aPlayer);
	}
	
	@Override
	public void onEaten(MultiItemRandom aItem, ItemStack aStack, EntityPlayer aPlayer) {
		mStats.onEaten(aItem, aStack, aPlayer);
	}
	
	@Override
	public void addAdditionalToolTips(MultiItemRandom aItem, List aList, ItemStack aStack, boolean aF3_H) {
		mStats.addAdditionalToolTips(aItem, aList, aStack, aF3_H);
	}
}