package gregapi.tileentity.multiblocks;

import static gregapi.data.CS.F;
import static gregapi.data.CS.NBT_STATE;
import static gregapi.data.CS.SIDES_VALID;
import static gregapi.data.CS.T;
import gregapi.data.TD;
import gregapi.tileentity.base.TileEntityBase09FacingSingle;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ChunkCoordinates;

/**
 * @author Gregorius Techneticies
 * 
 * Some Defaults for MultiBlock Machines.
 */
public abstract class TileEntityBase10MultiBlockBase extends TileEntityBase09FacingSingle implements ITileEntityMultiBlockController {
	public boolean mStructureChanged = F, mStructureOkay = F;
	
    @Override
	public void readFromNBT2(NBTTagCompound aNBT) {
    	super.readFromNBT2(aNBT);
        if (aNBT.hasKey(NBT_STATE+".str")) mStructureOkay = aNBT.getBoolean(NBT_STATE+".str");
    }
    
    @Override
	public void writeToNBT2(NBTTagCompound aNBT) {
    	super.writeToNBT2(aNBT);
    	UT.NBT.setBoolean(aNBT, NBT_STATE+".str", mStructureOkay);
    }
    
	@Override
    public void onTickFirst2(boolean aIsServerSide) {
    	super.onTickFirst2(aIsServerSide);
    	if (aIsServerSide) {
        	checkStructure(T);
    	}
    }
	
    @Override
    public void onTick2(long aTimer, boolean aIsServerSide) {
    	if (aIsServerSide) {
			if (mTimer % 600 == 5) doDefaultStructuralChecks();
    	}
    }
	
	@Override
	public long onToolClickMultiBlock(String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, List<String> aChatReturn, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, byte aSide, float aHitX, float aHitY, float aHitZ, ChunkCoordinates aFrom) {
		return onToolClick2(aTool, aRemainingDurability, aQuality, aPlayer, aChatReturn, aPlayerInventory, aSneaking, aStack, aSide, aHitX, aHitY, aHitZ);
	}
	
	@Override
	public boolean checkStructure(boolean aForceReset) {
		if (isClientSide()) return mStructureOkay;
		if (mStructureChanged || aForceReset) mStructureOkay = checkStructure2();
		mStructureChanged = F;
		return mStructureOkay;
	}
	
	@Override public void onFacingChange(byte aPreviousFacing) {onStructureChange();}
	
	@Override public boolean doDefaultStructuralChecks() {return T;}
	
	@Override public void onStructureChange() {mStructureChanged = T;}
	
	public abstract boolean checkStructure2();
}